regina::NSnapPeaCensusManifold Class Reference
Standard 3-Manifolds

Represents a 3-manifold from the SnapPea cusped census. More...

`#include <manifold/nsnappeacensusmfd.h>`

Inheritance diagram for regina::NSnapPeaCensusManifold:

## Public Member Functions

| NSnapPeaCensusManifold (char newSection, unsigned long newIndex)
| Creates a new SnapPea census manifold with the given parameters. More...
| NSnapPeaCensusManifold (const NSnapPeaCensusManifold &cloneMe)
| Creates a clone of the given SnapPea census manifold. More...
virtual | ~NSnapPeaCensusManifold ()
| Destroys this structure. More...
char | getSection () const
| Returns the section of the SnapPea census to which this manifold belongs. More...
unsigned long | getIndex () const
| Returns the index of this manifold within its particular section of the SnapPea census. More...
bool | operator== (const NSnapPeaCensusManifold &compare) const
| Determines whether this and the given structure represent the same 3-manifold from the SnapPea census. More...
NTriangulation * | construct () const
| Returns a triangulation of this 3-manifold, if such a construction has been implemented. More...
NAbelianGroup * | getHomologyH1 () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the common name of this 3-manifold as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the common name of this 3-manifold in TeX format to the given output stream. More...
std::ostream & | writeStructure (std::ostream &out) const
| Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream. More...
Public Member Functions inherited from regina::NManifold
virtual | ~NManifold ()
| A destructor that does nothing. More...
std::string | getName () const
| Returns the common name of this 3-manifold as a human-readable string. More...
std::string | getTeXName () const
| Returns the common name of this 3-manifold in TeX format. More...
std::string | getStructure () const
| Returns details of the structure of this 3-manifold that might not be evident from its common name. More...
bool | operator< (const NManifold &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold. More...
virtual void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
Public Member Functions inherited from regina::ShareableObject
| ShareableObject ()
| Default constructor that does nothing. More...
virtual | ~ShareableObject ()
| Default destructor that does nothing. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Static Public Attributes

static const char | SEC_5
| Represents the collection of manifolds formed from five or fewer tetrahedra (both orientable and non-orientable). More...
static const char | SEC_6_OR
| Represents the collection of orientable manifolds formed from six tetrahedra. More...
static const char | SEC_6_NOR
| Represents the collection of non-orientable manifolds formed from six tetrahedra. More...
static const char | SEC_7_OR
| Represents the collection of orientable manifolds formed from seven tetrahedra. More...
static const char | SEC_7_NOR
| Represents the collection of non-orientable manifolds formed from seven tetrahedra. More...

## Additional Inherited Members

Protected Member Functions inherited from regina::boost::noncopyable
| noncopyable ()
| A constructor which does nothing. More...
| ~noncopyable ()
| A destructor which does nothing. More...

## Detailed Description

Represents a 3-manifold from the SnapPea cusped census.

The SnapPea cusped census is the census of cusped hyperbolic 3-manifolds formed from up to seven tetrahedra. This census was tabulated by Callahan, Hildebrand and Weeks, and is shipped with SnapPea 3.0d3 (and also with Regina).

The census is split into five different sections according to number of tetrahedra and orientability. Each of these sections corresponds to one of the section constants defined in this class.

For further details regarding the SnapPea census, see "A census of cusped hyperbolic 3-manifolds", Patrick J. Callahan, Martin V. Hildebrand and Jeffrey R. Weeks, Math. Comp. 68 (1999), no. 225, pp. 321–332.

Note that this class is closely tied to NSnapPeaCensusTri. In particular, the section constants defined in NSnapPeaCensusTri and NSnapPeaCensusManifold are identical, and so may be freely mixed. Furthermore, the section and index parameters of an NSnapPeaCensusTri are identical to those of its corresponding NSnapPeaCensusManifold.

All of the optional NManifold routines are implemented for this class.

Test:
  Included in the test suite.

## Constructor & Destructor Documentation

regina::NSnapPeaCensusManifold::NSnapPeaCensusManifold | ( | char | newSection,
|  | unsigned long | newIndex
| ) |  |

inline

Creates a new SnapPea census manifold with the given parameters.

Parameters

  newSection | the section of the SnapPea census to which this manifold belongs. This must be one of the section constants defined in this class.
  newIndex | specifies which particular manifold within the given section is represented. The indices for each section begin counting at zero, and so this index must be between 0 and k-1, where k is the total number of manifolds in the given section.

regina::NSnapPeaCensusManifold::NSnapPeaCensusManifold | ( | const NSnapPeaCensusManifold & | cloneMe | ) |

inline

Creates a clone of the given SnapPea census manifold.

Parameters

  cloneMe | the census manifold to clone.

regina::NSnapPeaCensusManifold::~NSnapPeaCensusManifold | ( |  | ) |

inline virtual

Destroys this structure.

## Member Function Documentation

NTriangulation* regina::NSnapPeaCensusManifold::construct | ( |  | ) | const

virtual

Returns a triangulation of this 3-manifold, if such a construction has been implemented.

If no construction routine has yet been implemented for this 3-manifold (for instance, if this 3-manifold is a Seifert fibred space with sufficiently many exceptional fibres) then this routine will return 0.

The details of which 3-manifolds have construction routines can be found in the notes for the corresponding subclasses of NManifold. The default implemention of this routine returns 0.

Returns
  a triangulation of this 3-manifold, or 0 if the appropriate construction routine has not yet been implemented.

Reimplemented from regina::NManifold.

NAbelianGroup* regina::NSnapPeaCensusManifold::getHomologyH1 | ( |  | ) | const

virtual

Returns the first homology group of this 3-manifold, if such a routine has been implemented.

If the calculation of homology has not yet been implemented for this 3-manifold then this routine will return 0.

The details of which 3-manifolds have homology calculation routines can be found in the notes for the corresponding subclasses of NManifold. The default implemention of this routine returns 0.

The homology group will be newly allocated and must be destroyed by the caller of this routine.

Returns
  the first homology group of this 3-manifold, or 0 if the appropriate calculation routine has not yet been implemented.

Reimplemented from regina::NManifold.

unsigned long regina::NSnapPeaCensusManifold::getIndex | ( |  | ) | const

inline

Returns the index of this manifold within its particular section of the SnapPea census.

Note that indices for each section begin counting at zero.

Returns
  the index of this manifold within its section.

char regina::NSnapPeaCensusManifold::getSection | ( |  | ) | const

inline

Returns the section of the SnapPea census to which this manifold belongs.

This will be one of the section constants defined in this class.

Returns
  the section of the SnapPea census.

bool regina::NSnapPeaCensusManifold::operator== | ( | const NSnapPeaCensusManifold & | compare | ) | const

inline

Determines whether this and the given structure represent the same 3-manifold from the SnapPea census.

Parameters

  compare | the structure with which this will be compared.

Returns
  `true` if and only if this and the given structure represent the same SnapPea census manifold.

std::ostream& regina::NSnapPeaCensusManifold::writeName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold as a human-readable string to the given output stream.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

std::ostream& regina::NSnapPeaCensusManifold::writeStructure | ( | std::ostream & | out | ) | const

virtual

Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream.

For instance, for an orbit space S^3/G this routine might write the full Seifert structure.

This routine may write nothing if no additional details are deemed necessary. The default implementation of this routine behaves in this way.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Reimplemented from regina::NManifold.

std::ostream& regina::NSnapPeaCensusManifold::writeTeXName | ( | std::ostream & | out | ) | const

virtual

Writes the common name of this 3-manifold in TeX format to the given output stream.

No leading or trailing dollar signs will be included.

Warning
  The behaviour of this routine has changed as of Regina 4.3; in earlier versions, leading and trailing dollar signs were provided.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Returns
  a reference to the given output stream.

Implements regina::NManifold.

## Member Data Documentation

const char regina::NSnapPeaCensusManifold::SEC_5

static

Represents the collection of manifolds formed from five or fewer tetrahedra (both orientable and non-orientable).

There are 415 manifolds in this section.

const char regina::NSnapPeaCensusManifold::SEC_6_NOR

static

Represents the collection of non-orientable manifolds formed from six tetrahedra.

There are 259 manifolds in this section.

const char regina::NSnapPeaCensusManifold::SEC_6_OR

static

Represents the collection of orientable manifolds formed from six tetrahedra.

There are 962 manifolds in this section.

const char regina::NSnapPeaCensusManifold::SEC_7_NOR

static

Represents the collection of non-orientable manifolds formed from seven tetrahedra.

There are 887 manifolds in this section.

const char regina::NSnapPeaCensusManifold::SEC_7_OR

static

Represents the collection of orientable manifolds formed from seven tetrahedra.

There are 3552 manifolds in this section.

The documentation for this class was generated from the following file:

- manifold/nsnappeacensusmfd.h

Copyright © 1999-2013, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).